---
volumes:
  prometheus_data:
  grafana_data:

networks:
  frontend:
    name: frontend
    external: true
  backend:
    name: backend
    external: true

services:
{% if domain_name_enable %}
  caddy:
    image: caddy:latest
    container_name: caddy
    restart: unless-stopped
    ports:
      - "80:80"
      - "443:443"
      - "443:443/udp"
    networks:
      - frontend
      - backend
    volumes:
      - ./Caddyfile:/etc/caddy/Caddyfile
      - ./caddy_data:/data
      - ./caddy_config:/config
    cap_add:
      - NET_ADMIN
{% endif %}

  prometheus:
    image: prom/prometheus:latest
    restart: always
    volumes:
      - /etc/localtime:/etc/localtime:ro
      - ./prometheus/:/etc/prometheus/
      - prometheus_data:/prometheus
    command:
      - '--config.file=/etc/prometheus/prometheus.yml'
      - '--storage.tsdb.path=/prometheus'
      - '--storage.tsdb.retention.time={{ prometheus_tsdb_retention_time }}'
      - '--web.console.libraries=/usr/share/prometheus/console_libraries'
      - '--web.console.templates=/usr/share/prometheus/consoles'
    ports:
      - 9090:9090
    links:
      - ping:ping
      - speedtest:speedtest
    networks:
      - backend
{% if domain_name_enable and domain_name and domain_prometheus %}
    depends_on:
      - caddy
    environment:
      - VIRTUAL_HOST={{ domain_prometheus }}.{{ domain_name }}
      - VIRTUAL_PORT=9090
{% endif %}

  grafana:
    image: grafana/grafana:latest
    restart: always
    volumes:
      - /etc/localtime:/etc/localtime:ro
      - grafana_data:/var/lib/grafana
      - ./grafana/provisioning/:/etc/grafana/provisioning/
    ports:
      - 3000:3000
    env_file:
      - ./grafana/config.monitoring
    networks:
      - backend
      - frontend
    depends_on:
      - prometheus
{% if domain_name_enable and domain_name and domain_grafana %}
      - caddy
    environment:
      - VIRTUAL_HOST={{ domain_grafana }}.{{ domain_name }}
      - VIRTUAL_PORT=3000
{% endif %}

  ping:
    image: prom/blackbox-exporter:latest
    restart: always
    volumes:
      - /etc/localtime:/etc/localtime:ro
      - ./blackbox/config:/config
    stdin_open: true
    command:
      - '--config.file=/config/blackbox.yml'
    networks:
      - backend

  speedtest:
    image: miguelndecarvalho/speedtest-exporter:latest
    restart: always
    networks:
      - backend

  nodeexp:
    image: prom/node-exporter:latest
    restart: always
    privileged: true
    volumes:
      - /etc/localtime:/etc/localtime:ro
      - /proc:/host/proc:ro
      - /sys:/host/sys:ro
      - /:/rootfs:ro
    command:
      - '--path.procfs=/host/proc'
      - '--path.sysfs=/host/sys'
      - --collector.filesystem.ignored-mount-points
      - "^/(sys|proc|dev|host|etc|rootfs/var/lib/docker/containers|rootfs/var/lib/docker/overlay2|rootfs/run/docker/netns|rootfs/var/lib/docker/aufs)($$|/)"
    networks:
      - backend
